#include <X11/Xlib.h>
#include <X11/X.h>
#include <X11/Xutil.h>
#include "visual.h"

Display  *xdisplay;

GtkWidget 
  *Main;

GdkWindowAttr attr;

GdkPixmap 
  *LumPixmap;

GdkBitmap
  *LumMask;

Window 
  LumWindow,
  FocusWindow;

gint
  FocusX,
  FocusY;

void close_application( GtkWidget *Window, GdkEvent *Event, gpointer *Data )
{
  gtk_main_quit();
}

void init_window()
{
  xdisplay=XOpenDisplay(NULL);

  get_focus_window();
  Main = gtk_window_new ( GTK_WINDOW_TOPLEVEL );

  gtk_signal_connect( GTK_OBJECT(Main), "destroy",
		      GTK_SIGNAL_FUNC(close_application), NULL);
  gtk_widget_set_usize( Main, 120, 200 );

  attr.window_type = GDK_WINDOW_CHILD;
  attr.wclass = GDK_INPUT_OUTPUT;
  attr.x = FocusX;
  attr.y = FocusY;

  Main->window = gdk_window_new(
			  NULL, &attr, 0);
  gtk_widget_show(Main);
  gdk_window_show(Main->window);
  gdk_window_move(Main->window, (FocusX - FixX), (FocusY - FixY));

  return;
}


void init_pixmaps( gchar **Pixmap )
{
  

  LumPixmap = gdk_pixmap_create_from_xpm_d(
					  Main->window,
					  &LumMask,
					  NULL,
					  Pixmap);

return;

}

/********************************  Displaying Pixmaps  ************************/

gint display_pixmap(GdkPixmap *DisplayPixmap, GdkBitmap *DisplayMask )
{

   gdk_window_set_back_pixmap(
			     Main->window,
			     DisplayPixmap,
			     0);
   gdk_window_shape_combine_mask(
				Main->window,
				DisplayMask,
				0,0);
  gdk_window_clear(Main->window);
  gdk_flush();
 
  return(TRUE);
}

/*
 *
 * Callbacks to display different Pixmaps after waiting a set amount of time
 *
 */

gint display_lum()
{
  display_pixmap( LumPixmap, LumMask );
  return(FALSE);
}

void init_lum()
{
  init_pixmaps( lum_xpm );
}

gint window_raise()
{

  gdk_window_raise( Main->window );
  move_lum();
  
  return(TRUE);
}

void get_lum_window()
{
  gint
    revert_to;
  
  XGetInputFocus( xdisplay, &LumWindow, &revert_to );

  return;
}

void get_focus_window()
{

  Window    
    root, child_win;

  gint
    revert_to,
    rel_x,
    rel_y;
gint
    width,
    height,
    border,
    depth;

  XGetInputFocus( xdisplay, &FocusWindow, &revert_to );
  if( FocusWindow != 1 ){
  XGetGeometry( xdisplay, FocusWindow, &root, &rel_x, &rel_y,
		    &width, &height, &border, &depth);
  XTranslateCoordinates( xdisplay, FocusWindow, root,
			 rel_x, rel_y, &FocusX, &FocusY, &child_win );
 }
  return;
}

void move_lum()
{
  get_focus_window();
  
  if( LumWindow != FocusWindow ){
  gdk_window_move( Main->window, (FocusX - FixX), (FocusY - FixY) );
  };

  return;
}
